import React, { useState } from 'react';
import {
  Collapse,
  Navbar,
  NavbarToggler,
  NavbarBrand,
  Nav,
  NavItem
} from 'reactstrap';

import Link from 'next/link'

const BsNavLink = ({ title, href }) => {
  return <Link href={href}>
    <a className="nav-link port-navbar-link">{title}</a>
  </Link>
}

const BsNavBrand = ({ title, href }) => {
  return <Link href={href}>
    <a className="port-navbar-brand">{title}</a>
  </Link>
}

const LoginLink = () => {
  return <span className="nav-link port-navbar-link clickable">Login</span>
}

const LogoutLink = () => {
  return <span className="nav-link port-navbar-link clickable">Logout</span>
}

const Header = (props) => {
  const [isOpen, setIsOpen] = useState(false);

  const toggle = () => setIsOpen(!isOpen);

  return (
    <div>
      <Navbar
        className="port-navbar port-default absolute"
        color="transparent"
        dark expand="md">
        <BsNavBrand href="/" title="REACT x NEXT" />
        <NavbarToggler onClick={toggle} />
        <Collapse isOpen={isOpen} navbar>
          <Nav className="mr-auto" navbar>
            <NavItem className="port-navbar-item">
              <BsNavLink title='Home' href='/' />
            </NavItem>
            <NavItem className="port-navbar-item">
              <BsNavLink title='About' href='/about' />
            </NavItem>
            <NavItem className="port-navbar-item">
              <BsNavLink title='Portfolios' href='/portfolios' />
            </NavItem>
            <NavItem className="port-navbar-item">
              <BsNavLink title='Blogs' href='/blogs' />
            </NavItem>
            <NavItem className="port-navbar-item">
              <BsNavLink title='CV' href='/cv' />
            </NavItem>
            <NavItem className="port-navbar-item">
              {/* <BsNavLink title='Painterro' href='/editor' /> */}
              <a href='/editor' className="nav-link port-navbar-link">Painterro</a>
            </NavItem>
          </Nav>
          <Nav navbar>
            <NavItem className="port-navbar-item">
              <LoginLink />
            </NavItem>
            <NavItem className="port-navbar-item">
              <LogoutLink />
            </NavItem>
          </Nav>
        </Collapse>
      </Navbar>
    </div>
  );
}

export default Header