import { Component } from 'react'
import dynamic from 'next/dynamic'

import ClientSideOnlyRenderer from '../components/clientSideOnlyRenderer'

// const Paint = dynamic(() => import("../components/editor/paintero"), {
//   ssr: false,
// })

import Paint from '../components/editor/paintero'
import BaseLayout from '@/components/layouts/baseLayout'
import BasePage from '@/components/BasePage'

class Editor extends Component {
  static async getInitialProps({ req }) {
    return {
      isServer: !!req,
    };
  };

  renderDone() {
    return (
      <Paint />
    );
  }
  renderLoading() {
    return (<div>Loading...</div>);
  }
  render() {
    const { isServer } = this.props;
    return <BaseLayout>
      <BasePage>
        <ClientSideOnlyRenderer
          initialSsrDone={!isServer}
          renderDone={this.renderDone}
          renderLoading={this.renderLoading}
        />
        <div id='painterro' style={{ position: 'relative'}}></div>
      </BasePage>
    </BaseLayout>
  }
}

export default Editor