import BaseLayout from '@/components/layouts/baseLayout'
import BasePage from '@/components/BasePage'
import axios from 'axios'

const Portfolio = ({ portfolio }) => {
  return (
    <BaseLayout>
      <BasePage>
        <h1>I am portfolio page</h1>
        <h2>{portfolio.title}</h2>
        <p>{portfolio.body}</p>
        <p>{portfolio.id}</p>
      </BasePage>
    </BaseLayout>
  )
}

Portfolio.getInitialProps = async ({ query }) => {
  let post = {}
  try {
    const res = await axios.get(`https://jsonplaceholder.typicode.com/posts/${query.id}`)
    post = res.data
  } catch (e) {
    console.error(e)
  }

  return { portfolio: post }
}

export default Portfolio