import axios from "axios"
import Link from 'next/link'

import BaseLayout from '@/components/layouts/baseLayout'
import BasePage from '@/components/BasePage'
import { useEffect, useState } from "react"
import { useGetPosts } from '@/actions'

const Portfolios = () => {

  const { data, error, loading } = useGetPosts('/api/v1/posts')

  const renderPosts = (posts) => {
    return posts && posts.map((p) => <li key={p.id}>
      <Link as={`/portfolios/${p.id}`} href={`/portfolios/[id]`}>
        <a>
          {p.title}
        </a>
      </Link>
    </li>)
  }

  return (
    <BaseLayout>
      <BasePage>
        <h1> I am Portfolios page</h1 >
        {
          loading && <p>Loading...</p>
        }
        {
          data && <ul>
            {
              renderPosts(data)
            }
          </ul>
        }
        {
          error && <div className="alert alert-danger">{error.message}</div>
        }

      </BasePage>
    </BaseLayout>
  )
}

// Portfolios.getInitialProps = async () => {
//   let posts = []
//   try {
//     const res = await axios.get('https://jsonplaceholder.typicode.com/posts')
//     posts = res.data
//   } catch (e) {
//     console.error(e)
//   }

//   return { posts: posts.slice(0, 10) }
// }

export default Portfolios