import {
  genId
} from './utils';

export default class CommentTool {
  constructor(main) {
    this.comments = main.comments
    this.ctx = main.ctx;
    this.el = main.toolContainer;
    this.main = main;
    this.helperCanvas = document.createElement('canvas');
    this.canvas = main.canvas;
  }

  handleMouseDown(event) {
    if (event.path[0].className === 'far fa-trash-alt') {
      document.getElementById(this.commentId).remove();
    } else if (!this.main.colorPicker.opened && event.srcElement.tagName !== 'TEXTAREA' && event.srcElement.className !== 'far fa-comment-alt' && event.srcElement.className !== 'comment') {
      if (document.getElementsByClassName('comment-textarea --active').length > 0) {
        document.getElementById(this.activeComment)?.classList.toggle('--active')
      }
      this.creterComment(event)
    }
  }
  onClick(e, commentId, textareaId) {
    if (this.main.activeTool.name === 'comment') {
      if (this.activeComment === textareaId && e.srcElement.tagName !== 'TEXTAREA') {
        document.getElementById(textareaId).classList.toggle('--active')
        this.commentId = commentId
      } else {
        document.getElementById(this.activeComment)?.classList.remove('--active')
        document.getElementById(textareaId)?.classList.toggle('--active')
        this.commentId = commentId
        this.activeComment = textareaId
      }
    }
  }
  dragMouseUp() {
    this.movecomment = null
  }

  creterComment(event, comment) {
    const scale = this.main.getScale();
    const cord = [
      (event.clientX - this.main.elLeft()) + this.main.scroller.scrollLeft,
      (event.clientY - this.main.elTop()) + this.main.scroller.scrollTop,
    ];
    const cur = {
      x: cord[0] * scale,
      y: cord[1] * scale,
    };

    this.ptroWidth = parseInt(document.getElementsByClassName('ptro-crp-el')[0].style.width, 10)
    this.ptroHeight = parseInt(document.getElementsByClassName('ptro-crp-el')[0].style.height, 10)

    // console.log(gutterWidth, gutterHeight)
    // console.log(`left: calc(${gutterWidth} + ${(this.ptroWidth - (this.ptroWidth - cur.x)) / this.ptroWidth * 100}%)`)
    // console.log(this.main.substrate)
    // console.log(this.ptroWidth, this.ptroHeight)
    // console.log(`left: ${guterWidth - (this.ptroWidth - (this.ptroWidth - cur.x)) / this.ptroWidth * 100}%; top: ${guterHeight + (this.ptroHeight - (this.ptroHeight - cur.y)) / this.ptroHeight * 100}%;`)

    let creater = 0
    let html = document.createElement('div');
    html.id = genId()
    let htmlText = document.createElement('div');
    htmlText.id = genId()
    this.activeComment = htmlText.id
    this.commentId = html.id
    html.className = 'comment'
    html.innerHTML = (`<i class="far fa-comment-alt"></i>`)
    if (cur.x > 0 && cur.y > 0 && cur.x < this.ptroWidth && cur.y < this.ptroHeight) {
      htmlText.className = 'comment-textarea --active'
      htmlText.innerHTML = this.formComment()
      html.children[0].style.cssText = `color: ${this.main.colorPicker.alphaColor || this.main.params.activeColor};`
      html.style.cssText = `left: ${(this.ptroWidth - (this.ptroWidth - cur.x)) / this.ptroWidth * 100}%; top: ${(this.ptroHeight - (this.ptroHeight - cur.y)) / this.ptroHeight * 100}%;`
      creater = 1
    } else if (comment) {
      htmlText.className = 'comment-textarea'
      htmlText.innerHTML = this.formComment(comment?.data)
      html.children[0].style.cssText = comment?.color
      html.style.cssText = comment?.position
      creater = 1
    }
    this.main.comments.push({
      position: `left: ${(this.ptroWidth - (this.ptroWidth - cur.x)) / this.ptroWidth * 100}%; top: ${(this.ptroHeight - (this.ptroHeight - cur.y)) / this.ptroHeight * 100}%;`,
      color: `color: ${this.main.colorPicker.alphaColor || this.main.params.activeColor};`,
      data: '',
    })
    this.main.worklog.captureState()
    if (creater) {
      html.appendChild(htmlText)
      this.main.toolContainer.appendChild(html)
      document.getElementById(html.id).onclick = (e) => this.onClick(e, html.id, htmlText.id);
      document.getElementById(html.id).ontouchstart = (e) => this.onMouseDown(e, scale)
      document.getElementById(html.id).onmousedown = (e) => this.onMouseDown(e, scale)
      document.getElementById(html.id).onmouseup = this.dragMouseDown;
    }
  }
  onMouseDown(e, scale) {
    e = e || window.event;

    if (e.path?.[0]?.tagName !== 'TEXTAREA') {
      e.preventDefault();
      this.movecomment = e.path[1].id
      if (this.movecomment) {
        // get the mouse cursor position at startup:
        this.pos3 = e.clientX;
        this.pos4 = e.clientY;
        document.onmouseup = () => {
          /* stop moving when mouse button is released:*/
          document.onmouseup = null;
          document.onmousemove = null;
        };
        // // call a function whenever the cursor moves:
        document.onmousemove = (e) => {
          e = e || window.event;
          e.preventDefault();
          // calculate the new cursor position:

          this.pos1 = this.pos3 - e.clientX;
          this.pos2 = this.pos4 - e.clientY;
          this.pos3 = e.clientX;
          this.pos4 = e.clientY;

          // set the element's new position:
          let em = document.getElementById(this.movecomment)
          let top = em.offsetTop - this.pos2
          let left = em.offsetLeft - this.pos1

          const cord = [
            (e.clientX - this.main.elLeft()) + this.main.scroller.scrollLeft,
            (e.clientY - this.main.elTop()) + this.main.scroller.scrollTop,
          ];
          const cur = {
            x: cord[0] * scale,
            y: cord[1] * scale,
          };

          // console.log(`${top} < ${this.ptroHeight - 20} && ${top} > ${0 - 10} && ${left} < ${this.ptroWidth - 20} && ${left} > ${0 - 10}`)
          if (top < this.ptroHeight - 20 && top > 0 - 10 && left < this.ptroWidth - 20 && left > 0 - 10) {
            let perHeight = (this.ptroHeight - (this.ptroHeight - cur.y)) / this.ptroHeight * 100
            let perWidth = (this.ptroWidth - (this.ptroWidth - cur.x)) / this.ptroWidth * 100
            if (perHeight <= 0) {
              em.style.top = `0%`
              em.style.left = `${perWidth}%`
            } else if (perWidth <= 0) {
              em.style.top = `${perHeight}%`
              em.style.left = `0%`
            } else if (perHeight >= this.ptroHeight - 20) {
              em.style.top = `${this.ptroHeight - 20}%`
              em.style.left = `${perWidth}%`
            } else if (perWidth >= this.ptroWidth - 20) {
              em.style.top = `${perHeight}%`
              em.style.left = `${this.ptroWidth - 20}% `
            } else {
              em.style.top = `${perHeight}% `
              em.style.left = `${perWidth}% `
            }
          }
        }
      }
    }
  }

  formComment(data) {
    return `<div>
    <div>
      <textarea id="comment" name="comment" rows="4" cols="50">${data || ''}</textarea>
    </div>
    <div>
      <i color='red' class="far fa-trash-alt"></i>
    </div>
  </div>`
  }
}